package info.aspirecn.cloud.yysj.entity;


import java.util.List;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Author: bzh
 * @Description: 编辑某用户的某产品的路由信息,此处编辑同步产品的信息和异步产品的价格信息,异步产品的回调地址需在用户库修改
 */
@ApiModel(description = "编辑路由价格信息请求类")
@Data
public class EditRoutePriceInfoReq {
    @ApiModelProperty("用户nid")
    private Integer userNid;
    @ApiModelProperty("产品的sid")
    private String productSid;
    @ApiModelProperty("路由价格")
    private Integer price;

    @ApiModelProperty("第二路由价格")
    private Integer secondPrice;

    @ApiModelProperty("启用")
    private Integer secondPriceEable;
    @ApiModelProperty("缓存标志")
    private Integer cacheSign;
    @ApiModelProperty("回调地址")
    private String callbackUrl;
    @ApiModelProperty("路由通道集合")
    private List<ChannelInfo> channelInfos;
    @ApiModelProperty("是否固定价格")
    private String ifFixedPrice;
    @ApiModelProperty("预测单数")
    private String forecastNum;

    @ApiModelProperty(value = "次/日")
    private String dayMaxNum;
    @ApiModelProperty(value = "次/月")
    private String mouthMaxNum;

    @Data
    @ApiModel(description = "产品下的通道路由信息")
    public static class ChannelInfo{
        @ApiModelProperty("通道sid")
        private String channelSid;
        @ApiModelProperty("通道优先级")
        private Integer order;
        @ApiModelProperty("切换条件 可选值: error timeout")
        private List<SwitchCondition> switchCondition;
        @ApiModelProperty("超时时间")
        private Integer timeout;
        @ApiModelProperty("返回结果集")
        private String result;
        
    }
}
