package info.aspirecn.cloud.yysj.entity;


import java.util.List;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Author: bzh
 * @Description:
 */
@Data
@ApiModel(description = "产品管理列表")
public class ProductManagerListRes {
    @ApiModelProperty("集合总条数")
    private int total;
    @ApiModelProperty("集合信息")
    private List<ProductManagerInfo> list;

    @Data
    @ApiModel(description = "产品管理信息")
    public static class ProductManagerInfo{
        @ApiModelProperty("产品名称")
        private String name;
        @ApiModelProperty("产品Id")
        private Integer id;
        @ApiModelProperty("产品SId")
        private String sid;
        @ApiModelProperty("建议零售价")
        private Integer price;
        @ApiModelProperty("通道分类名称")
        private String channelClassifyName;
        @ApiModelProperty("通道分类Id")
        private String channelClassifySId;
        @ApiModelProperty("下属通道集合数量")
        private String channelCount;
        @ApiModelProperty("下属通道集合")
        private List<ChannelInfo> list;
        @ApiModelProperty("产品状态 1:上线 3:下线")
        private Integer status;
        @ApiModelProperty("产品类型 31:实时 31:异步")
        private Integer productType;
        @ApiModelProperty("创建时间 格式:yyyy-MM-dd")
        private String createtime;
    }

    @Data
    @ApiModel(description = "产品下属通道信息")
    public static class ChannelInfo{
        @ApiModelProperty("通道Id")
        private String channelId;
        @ApiModelProperty("通道名称")
        private String channelName;
    }

}
