package info.aspirecn.cloud.yysj.service;

import java.util.List;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import info.aspirecn.cloud.yysj.entity.EditRoutePriceInfoReq;
import info.aspirecn.cloud.yysj.entity.ProductDetailRes;
import info.aspirecn.cloud.yysj.entity.ProductManagerListReq;
import info.aspirecn.cloud.yysj.entity.ProductManagerListRes;
import info.aspirecn.cloud.yysj.entity.UserProductPo;

//@FeignClient(value = "http://10.8.18.171:20180",url = "http://10.8.18.171:20180")
@FeignClient(value = "http://iov-sjjh-servicenode-channel.iov-sjjh:8080",url = "http://iov-sjjh-servicenode-channel.iov-sjjh:8080")
public interface SjjhProductService {
	
	 /**根据多个产品id获取产品详情,包括删除与未删除*/
	 @RequestMapping(value = "/getDetailListByIds.do",method = RequestMethod.POST)
	 public List<ProductDetailRes> getDetailListByIds(@RequestBody List<Integer> ids);
	 
	  /** 查询产品管理列表 */
	 @RequestMapping(value = "/productMgtList.do",method = RequestMethod.POST)
	 public ProductManagerListRes productMgtList(@RequestBody ProductManagerListReq productManagerListReq);
	 
	  /** 产品配置添加产品和路由信息或者配置路由信息 */
	 @RequestMapping(value = "/addOrEditRouteInfo.do",method = RequestMethod.POST)
	 public Integer addOrEditRouteInfo(@RequestBody EditRoutePriceInfoReq editRoutePriceInfoReq);
	 
	  /** 客户删除产品 */
	 @RequestMapping(value = "/delProductForCustomer.do",method = RequestMethod.POST)
	 public Integer delProductForCustomer(@RequestParam("userId")Integer userId, @RequestParam("productSid")String productSid);
	 
	 @RequestMapping(value = "/getUserPriceList.do",method = RequestMethod.POST)
	 public UserProductPo userPriceList(@RequestParam(value="userId")Integer userId,@RequestParam("start")Integer start,@RequestParam("size")Integer size,@RequestParam(value="productSid",required = false)String productSid);
	   
}
