package info.aspirecn.cloud.yysj.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import info.aspirecn.cloud.yysj.entity.EditRoutePriceInfoReq;
import info.aspirecn.cloud.yysj.entity.EditRoutePriceInfoReq.ChannelInfo;
import info.aspirecn.cloud.yysj.entity.Produce;
import info.aspirecn.cloud.yysj.entity.ProduceRelevance;
import info.aspirecn.cloud.yysj.entity.ProductDetailRes;
import info.aspirecn.cloud.yysj.entity.ProductManagerListReq;
import info.aspirecn.cloud.yysj.entity.ProductManagerListRes;
import info.aspirecn.cloud.yysj.entity.SjjhProduce;
import info.aspirecn.cloud.yysj.entity.SwitchCondition;
import info.aspirecn.cloud.yysj.entity.User;
import info.aspirecn.cloud.yysj.entity.UserProduce;
import info.aspirecn.cloud.yysj.entity.UserProductPo;
import info.aspirecn.cloud.yysj.mapper.ProductMapper;
import info.aspirecn.cloud.yysj.mapper.UserMapper;
import info.aspirecn.cloud.yysj.service.ProductService;
import info.aspirecn.cloud.yysj.service.SjjhProductService;
import info.aspirecn.cloud.yysj.util.RedisUtil;

@Service
@Transactional
public class  ProductServiceImpl implements ProductService {

	 /** 数据交互经营许可证产品编号 */
     @Value("${product.permitProductId1}")
     private  Integer permitProductId1;
     
     @Value("${product.permitProductId2}")
     private  Integer permitProductId2;
	
	 @Autowired
	 private UserMapper userMapper;
	 
	 @Autowired
	 private ProductMapper productMapper;
	 
	 @Autowired
	 private SjjhProductService sjjhProductService;

     @Autowired
     private RedisUtil redisUtil;
	 
	
	@Override
	public Integer saveUserProduce(String userId,UserProduce userProduce) {
		User user=userMapper.getUserByUserId(userId);
		List<ProduceRelevance> list= productMapper.getProductByProduceId(userProduce.getProduceId());
		Integer state=0;
		if (list.size()>0&&user!=null) {
			for (int i = 0; i < list.size(); i++) {
				List<Integer> ids=new ArrayList<Integer>();
				ids.add(list.get(i).getSjjhId());
				List<ProductDetailRes> detailRes=sjjhProductService.getDetailListByIds(ids);
				if (detailRes.size()>0) {
					ProductManagerListReq productManagerListReq=new ProductManagerListReq();
					productManagerListReq.setSid(detailRes.get(0).getSid());
					productManagerListReq.setProductType(32);
					productManagerListReq.setStatus(1);
					productManagerListReq.setPageNum(1);
					productManagerListReq.setPageSize(1);
					ProductManagerListRes productManagerListRes=sjjhProductService.productMgtList(productManagerListReq);
					if (productManagerListRes.getList().size()>0) {
						for (int j = 0; j < productManagerListRes.getList().size(); j++) {
							EditRoutePriceInfoReq editRoutePriceInfoReq=new EditRoutePriceInfoReq();
							editRoutePriceInfoReq.setUserNid(user.getSjjhUserId());
							editRoutePriceInfoReq.setProductSid(productManagerListRes.getList().get(j).getSid());
							editRoutePriceInfoReq.setPrice(productManagerListRes.getList().get(j).getPrice());
							editRoutePriceInfoReq.setIfFixedPrice("1");
							editRoutePriceInfoReq.setCacheSign(0);
							editRoutePriceInfoReq.setSecondPriceEable(0);
							List<ChannelInfo> listChannelInfo=new ArrayList<ChannelInfo>();
							for (int k = 0; k < productManagerListRes.getList().get(j).getList().size(); k++) {
								ChannelInfo channelInfos=new ChannelInfo();
								channelInfos.setChannelSid(productManagerListRes.getList().get(j).getList().get(k).getChannelId());
								channelInfos.setOrder(1);
								List<SwitchCondition> listSwitchCondition=new ArrayList<SwitchCondition>();
								SwitchCondition switchCondition=new SwitchCondition();
								switchCondition.setSwitchCondition("timeout");
								switchCondition.setSeconds(3000);
								listSwitchCondition.add(switchCondition);
								SwitchCondition switchCondition1=new SwitchCondition();
								switchCondition1.setSwitchCondition("returnResult");
								switchCondition1.setSeconds(0);
								switchCondition.setResult("3");
								listSwitchCondition.add(switchCondition1);
								channelInfos.setSwitchCondition(listSwitchCondition);
								listChannelInfo.add(channelInfos);
							}
							editRoutePriceInfoReq.setChannelInfos(listChannelInfo);
							Integer addOrEditRouteInfo = sjjhProductService.addOrEditRouteInfo(editRoutePriceInfoReq);
							if (addOrEditRouteInfo==1) {
								redisUtil.del("yyshcore::getUserProduct_"+userId+"_"+list.get(i).getType());
								 if (!permitProductId1.equals(list.get(i).getSjjhId())) {
									 state= productMapper.saveUserProduce(userId,userProduce.getProduceId(),new Date());	
									 userProduce.setUserId(userId);
							    	 userProduce.setEvent(1);
							         userProduce.setCreateTime(new Date());
							         productMapper.saveUserProduceEvent(userProduce);
								 }
							}
						}
					}
			
				}
			}
				
		 }
		return state;
	}
	
	@Override
	public List<UserProduce> queryUserProduce(String userId, Integer produceId) {
		return productMapper.queryUserProduce(userId,produceId);
	}

	@Override
	public Integer deleteUserProduce(String userId, Integer produceId,String produceName) {
		User user=userMapper.getUserByUserId(userId);
		List<ProduceRelevance> list= productMapper.getProductByProduceId(produceId);
		Integer state=0;
		for (int i = 0; i < list.size(); i++) {
			List<Integer> ids=new ArrayList<Integer>();
			ids.add(list.get(i).getSjjhId());
			List<ProductDetailRes> detailRes=sjjhProductService.getDetailListByIds(ids);
			if (detailRes.size()>0) {
				for (int j = 0; j < detailRes.size(); j++) {
					Integer delProductForCustomer = sjjhProductService.delProductForCustomer(user.getSjjhUserId(), detailRes.get(j).getSid());
					if (delProductForCustomer==1) {
						redisUtil.del("yyshcore::getUserProduct_"+userId+"_"+list.get(i).getType());
						redisUtil.del("sjjhcore::getRouteDetailByProductIdAndUserId_"+detailRes.get(j).getId()+"_"+user.getSjjhUserId());
						state= productMapper.deleteUserProduce(userId,produceId);	
						if (state==1) {
							UserProduce userProduce=new UserProduce();
					    	userProduce.setUserId(userId);
					    	userProduce.setProduceId(produceId);
					    	userProduce.setEvent(0);
					    	userProduce.setProduceName(produceName);
					    	userProduce.setCreateTime(new Date());
					    	productMapper.saveUserProduceEvent(userProduce);
						}
					}
				}
			}
		}
		return state;
	}

@Override
	public Map<String, Integer> getOrderProductCount(String userId) {
		//获取云雁所有产品
		List<Produce> producesAllList=productMapper.getAllProductList(null);
		User userByUserId = userMapper.getUserByUserId(userId);
		//调用数据交互服务，获取产品价格
		UserProductPo userPriceList = sjjhProductService.userPriceList(userByUserId.getSjjhUserId(), 0, 9999, null);
		Iterator<Produce> producesIter = producesAllList.iterator();
		int orderProductCount=0;
		int chargeOrderProductCount=0;
		 while(producesIter.hasNext()){
			 Produce produce = producesIter.next();
			 for (int j = 0; j < userPriceList.getUserProducts().size(); j++) {
					if (produce.getSjjhId().equals(userPriceList.getUserProducts().get(j).getProductId())) {
						if (produce.getSjjhId().equals(permitProductId1)) {
							producesIter.remove();
						}else {
							if (userPriceList.getUserProducts().get(j).getBuySign()==1) {
								orderProductCount++;
								if (userPriceList.getUserProducts().get(j).getPrice()>0) {
									chargeOrderProductCount++;
								}
							}
						}
					}
				}
			 
		 }		
		Map<String, Integer>  map=new HashMap<String, Integer>();
		map.put("orderProductCount", orderProductCount);
		map.put("chargeOrderProductCount", chargeOrderProductCount);
		return map;
	}

	@Override
	public Map<String, Object> getProductList(String userId,String productName, int pageNum, int pageSize) {
		//获取云雁所有产品
		List<Produce> producesAllList=productMapper.getAllProductList(productName);
		User userByUserId = userMapper.getUserByUserId(userId);
		//调用数据交互服务，获取产品价格
		UserProductPo userPriceList = sjjhProductService.userPriceList(userByUserId.getSjjhUserId(), 0, 9999, null);
		List<Produce> list=new ArrayList<Produce>();
		if (userPriceList!=null) {
			Integer price=0;
			Iterator<Produce> producesIter = producesAllList.iterator();
			 while(producesIter.hasNext()){
				 Produce produce = producesIter.next();
				 for (int j = 0; j < userPriceList.getUserProducts().size(); j++) {
						if (produce.getSjjhId().equals(userPriceList.getUserProducts().get(j).getProductId())) {
							if (produce.getSjjhId().equals(permitProductId1)) {
								price+=Integer.valueOf(userPriceList.getUserProducts().get(j).getPrice());
							}else {
								if (produce.getSjjhId().equals(permitProductId2)) {
									produce.setPrice(priceprocess(String.valueOf(userPriceList.getUserProducts().get(j).getPrice()+price)));
									produce.setIsOrder(userPriceList.getUserProducts().get(j).getBuySign());
									list.add(produce);
								}else {
									produce.setPrice(priceprocess(String.valueOf(userPriceList.getUserProducts().get(j).getPrice())));
									produce.setIsOrder(userPriceList.getUserProducts().get(j).getBuySign());
									list.add(produce);
								}
								
							}
							 //用查询用户是否订购产品
			            	 List<UserProduce> queryUserProduce = productMapper.queryUserProduce(userId,produce.getId());
							if (queryUserProduce.isEmpty()&&userPriceList.getUserProducts().get(j).getBuySign()==1) {
								//用户订购产品
								productMapper.saveUserProduce(userId,produce.getId(),new Date());	
						    	UserProduce userProduce=new UserProduce();
								userProduce.setUserId(userId);
								userProduce.setProduceId(produce.getId());
						    	userProduce.setEvent(userPriceList.getUserProducts().get(j).getBuySign());
						    	userProduce.setProduceName(produce.getProduceName());
						    	userProduce.setCreateTime(new Date());
						    	productMapper.saveUserProduceEvent(userProduce);
							}
							//用户取消订购
							if (queryUserProduce.size()>0&&userPriceList.getUserProducts().get(j).getBuySign()==0) {
								productMapper.deleteUserProduce(userId,produce.getId());	
								UserProduce userProduce=new UserProduce();
						    	userProduce.setUserId(userId);
						    	userProduce.setProduceId(produce.getId());
						    	userProduce.setEvent(0);
						    	userProduce.setProduceName(produce.getProduceName());
						    	userProduce.setCreateTime(new Date());
						    	productMapper.saveUserProduceEvent(userProduce);
							}
						}
					}
				 
			 }
			 if (!list.isEmpty()) {
				 list.sort((x, y) -> Integer.compare(y.getIsOrder(), x.getIsOrder()));
			}
		}
	    Integer count = list.size(); //记录总数
        Integer pageCount = 0; //页数
        if (count % pageSize == 0) {
            pageCount = count / pageSize;
        } else {
            pageCount = count / pageSize + 1;
        }
        int fromIndex = 0; //开始索引
        int toIndex = 0; //结束索引
        if(pageNum > pageCount){
            pageNum = pageCount;
        }
        if (pageNum!=pageCount) {
            fromIndex = (pageNum - 1) * pageSize;
            toIndex = fromIndex + pageSize;
        } else {
            fromIndex = (pageNum - 1) * pageSize;
            toIndex = count;
        }
		Map<String, Object> map=new HashMap<String, Object>();
		map.put("dataList", list.subList(fromIndex, toIndex));
		map.put("total", count);
		return map;
	}
	
	@Override
	public List<Produce> getProductNameList() {
		return productMapper.getAllProductList(null);
	}

	@Override
	public void saveProduce(Produce produce) {
		produce.setCreateTime(new Date());
		produce.setUpdateTime(new Date());
		productMapper.saveProduce(produce);	
		SjjhProduce sjjhProduce=new SjjhProduce();
		sjjhProduce.setYysjId(produce.getId());
		sjjhProduce.setSjjhId(produce.getSjjhId());
		sjjhProduce.setCreateTime(new Date());
		sjjhProduce.setUpdateTime(new Date());
		productMapper.saveSjjhProduce(sjjhProduce);
	}
	/**
	 * 处理价格单位
	 */
	private static String priceprocess(String price){
	    // 获取签名部分
	    if (price.length() == 1){
	        return "0.00" + price;
	    } else if (price.length() == 2){
	        return "0.0" + price;
	    } else if (price.length() == 3){
	        return "0." + price;
	    }
	    // 获取签名部分
	    String pricePre = StringUtils.substring(price,0,price.length()-3);
	    // 获取后面部分
	    String pricePost = StringUtils.substring(price,price.length()-3,price.length());
	    // 拼接
	    return pricePre + "." + pricePost;
	}
}
